#ifndef GARBAGE_COLLECTOR_H
#define GARBAGE_COLLECTOR_H

#include <stdlib.h>
#include "linked_list.h"

#define DECLARE_GC(NAME) \
DECLARE_LIST(NAME); \
static void _throw_away_##NAME() { \
	ITERATOR(NAME) = NAME; \
	do { \
		free(ITERATOR(NAME)->elem == NULL ? NULL : *(void **)ITERATOR(NAME)->elem); \
	} while ((ITERATOR(NAME) = ITERATOR(NAME)->next) != NULL); \
	DESTROY_LIST(NAME); \
}

#define INITIALIZE_GC(NAME) INITIALIZE_LIST(NAME)

#define GC_ALLOC(TYPE, TARGET, LEN, GC_NAME) \
do { \
	TARGET = (TYPE *)malloc((LEN) * sizeof(TYPE)); \
	PUSH(void *, TARGET, GC_NAME); \
} while (0)

#define GC_FREE(NAME) _throw_away_##NAME()

#endif